/*
 * Soanca Cristian-Adrian
 * 334CC
 */
 
#define __PROG_TYPES_COMPAT__
#include <avr/pgmspace.h>
#include <stdlib.h>
#include <stdio.h>
#include <util/delay.h>
#include "gfx.h"


/* Functia de buzzer din lab0 */
void buzzer_morse(int tip_morse) {
	int i;

	/* Alternam starea pinului PD5 la fiecare milisecunda. */
	for (i = 0; i < tip_morse; ++i) {
		PORTD ^= (1 << PD5);

		_delay_ms(1);
	}
}

typedef struct point_t {
	int x;
	int y;
} point_t;

/* Variables */
int size = 5, x, y;
point_t snake[100];
point_t head;
point_t tail;

/* Functions */

/* Functio to set up the env and ports */
void start() {

	/* Setez pinul PD5 ca iesire. */
	DDRD |= (1 << PD5);

	/* Opresc buzzer-ul. */
	PORTD &= ~(1 << PD5);
	
	/* Forward */
    DDRC &= ~(1 << PC5);
    PORTC |= (1 << PC5);
	
	
	fillScreen(Color565(255, 255, 255));
	
	x = _width / 2;
	y = _height / 2;
	
	head.x = snake[0].x = x;
	head.y = snake[0].y = y;
	fillRect(snake[0].x, snake[0].y, size, size, Color565(192,0,0));
	
	int i;

	for (i = 1; i < 4; i++) {
		tail.x = snake[i].x = snake[i-1].x - size;
		tail.y = snake[i].y = snake[i-1].y;
		fillRect(tail.x, tail.y, size, size, Color565(192,0,0));
	}
	
	for (i = 0; i < _width; i++) {
		fillRect(i, _height- 5, size, size, Color565(192,0,0));
		fillRect(i, _height - 160, size, size, Color565(192,0,0));
	}
	
	for (i = 0; i < _height; i++) {
		fillRect(0, i, size, size, Color565(192,0,0));
		fillRect(_width-5, i, size, size, Color565(192,0,0));
	}
}

int main(void){

	init();
 
    start();
		
    return 0;
}